% !TEX root = ../toptesi-scudo-example.tex
% !TEX encoding = UTF-8 Unicode
% ******************************* Thesis Appendix D 

\chapter{Android Location Services}
\label{appendix:android_locServ}

\graphicspath{{Appendix5/Figures}}

\section{Background software architecture: Positioning in Android OS}

Dealing with time-constrained \ac{GNSS} measurements requires to act at very low level in the system architecture but unfortunately this cannot be achieved with smartphones when we work at the application level. As shown in Figure \ref{fig:cpa_where}, the Android Application Framework works as an interface to access sensors measurements and this holds also for the \ac{GNSS} receiver. Different \ac{API}s allow to the developers to exploit positioning and navigation capabilities in Android smartphones.

As an affordable solution within the roadmap of the project, \ac{CAPS.loc} has been initially deployed at application level but potential implementations at lower system level (e.g. operating system background services) are surely of interest for further development. 

\subsection{Android Location Manager}

Android gives to the applications the access to the location services supported by the device through classes in the \texttt{android.location} package. The central component of the location framework is the \texttt{LocationManager} system service, which provides \ac{API}s to determine location and bearing (if compass sensor is available) of the underlying device. 

Once a given application is registered to the \texttt{LocationManager} service, it is able to
perform three actions:

\begin{itemize}
\item Query for the list of all \texttt{LocationProviders} for the last known user location.
\item Register/unregister for periodic updates of the user's current location from
a location provider (specified either by criteria or name).
\item Register/unregister for a given Intent to be fired if the device comes within
a given proximity (specified by radius in meters) of a given latitude and longitude.
\end{itemize}

The \texttt{LocationProvider} class is the superclass of the different location providers which deliver the information about the current location. This information is stored in the Location class.
The Android's location \ac{API}s use three different providers to get location

\begin{itemize}
\item \texttt{LocationManager.GPS\_PROVIDER}: This provider determines location
using satellites only. Depending on conditions (i.e. visibility, signal quality, demodulation of the navigation message), this provider may require a considerable time to return a location fix. The \texttt{GPS\_PROVIDER} foreseen accurate, precise and reliable solutions according to the quality of the on-board \ac{GNSS} receiver.
\item \texttt{LocationManager.NETWORK\_PROVIDER}: This provider determines
location based on availability of cell tower and Wi-Fi access points by exploiting their geo-tags or RSS measurements. Results are retrieved by means of a network lookup so the responsiveness of the \texttt{NETWORK\_PROVIDER} depends on network latencies. 
\item \texttt{LocationManager.PASSIVE\_PROVIDER}: This provider will return locations generated by other providers. The location is updated when other applications or services request them without actually requesting the locations yourself.
\end{itemize}

Some challenging aspects must be taken into account in determining the location of a device, 
some sources of error in the user location indeed include:

\begin{itemize}
\item \textbf{Multitude of location sources} - \ac{GNSS}, Cell-ID, and Wi-Fi can each provide a
clue to users location. Determining which to use and trust is a matter of trade-offs in accuracy, speed, and battery-efficiency.
\item \textbf{User movement} - Because the user location changes, you must account for movement by re-estimating user location every so often. To cope with such a typical issue for highly-portable devices, the integration of on-board inertial sensors has become very appealing to guarantee better accuracy and precision.
\item \textbf{Varying accuracy} - Location estimates coming from each location source are not consistent in their accuracy. As an example, the location obtained at a given epoch from one source might be more accurate than the newest location from another or same source. This issue hold for all the location providers implemented in the Android location framework.
\end{itemize}

These problems can make it difficult to obtain a reliable user location. 

The usual way to obtain the location in Android devices works by means of callbacks. An application can receive location updates from the \texttt{LocationManager} by calling \texttt{requestLocationUpdates()}, passing it a \texttt{LocationListener}. Your \texttt{LocationListener} must implement several callback methods that the \texttt{LocationManager} calls when the user location changes or when the status of the service changes.

The high-level localization options offered to the Android users reflect the potential of the location provider so that it can be forced the only use of \ac{GNSS} and on-board inertial sensors (device only), Networks only (low power) and a combined solution (high accuracy) which guarantees the best performance in terms of accuracy, precision and availability of the positioning solution. 

\subsection{Raw GNSS measurements}

Raw pseudorange and Doppler measurements are provided as an output by the \textit{Raw GNSS Measurement} \ac{API}. All the information related to the \ac{GNSS} receiver are hence encapsulated in a Java public class named \texttt{GnssMeasurement}. Further details about method and constant provided by the object android.location.GnssMeasurement can be found at \url{https://developer.android.com/reference/android/location/GnssMeasurement.html}. The reference positioning solution is foreseen by the Google Fused Location Provider which integrates available sensors and networks to refine the positioning estimation provided by means of \ac{GNSS}, as shown in the right scheme of Figure \ref{fig:cpa_where}.  

\begin{figure}[h!]
\centering
\includegraphics[width=1\columnwidth,trim={0cm 0cm 0cm 0cm},clip]{/schema_android.png}
\caption{{\small Possible implementation of the \ac{CAPS.loc} framework in Android systems}.}
\label{fig:cpa_where}
\end{figure}



%\begin{figure}[h!]
%\centering
%\includegraphics[width=0.75\columnwidth,trim={0cm 0cm 0cm 0cm},clip]{/hansel/fused.png}
%\caption{{\small Fused location provider using Google Play Service API}}
%\label{fig:fusedLocation}
%\end{figure}

For this reasons the development of the \ac{CAPS.loc} framework has been pursued at this level by knowing potential limits imposed by the operating system itself w.r.t. the management of the applications. 

\subsubsection{Fused Location Provider API}

As shown in the right portion of Figure \ref{fig:cpa_where}, the new paradigm aim at providing to the developer and to the users different layers. The Fused Location Provider is compatible with lower level sensors hubs which can be tightly-integrated prior to the application level. The Google Fused Location Provider has been used in the HANSEL project only to assess the improvement guaranteed by cooperative positioning w.r.t. the standalone \ac{GNSS} solution.

Nevertheless, a natural extension of the \ac{CAPS.loc} would act in synergy with other location providers, tightly related or augmenting to the capabilities of the \ac{GNSS} receiver, as for the block scheme on the right of Figure \ref{fig:cpa_where}. 


